config/routes.rb
# encoding: UTF-8

# Routes
Rails.application.routes.draw do
  # Bookings
  resources :bookings do
    collection do
      post :select
    end
    member do
      get :select_booking
      get :copy
    end
  end

  resources :accounts do
    member do
      get :csv_bookings
      get :edit_bookings
      post :update_bookings
    end
    resources :bookings
    resources :attachments
  end

  resources :banks do
    resources :phone_numbers
    member do
      get :new_phone_number
    end
    collection do
      get :new_phone_number
    end
  end

  resources :bank_accounts do
    member do
      get :csv_bookings
    end
    resources :bookings
    resources :attachments
  end

  resources :booking_templates do
    member do
      get :new_booking
    end
  end
end

app/helpers/has_accounts_helper.rb
module HasAccountsHelper
  include ActionView::Helpers::NumberHelper
  def currency_fmt(value)
    # We often do get -0.0 but don't like it
    value = 0.0 if value.to_s.match %r{^-[0.]*$}

    number = number_with_precision(value, :precision => 2, :separator => '.', :delimiter => "'")
  end
end

app/views/has_accounts/_form.html.haml
= simple_form_for resource do |f|

  = f.inputs

  = f.button :submit

app/views/has_accounts/_list.html.haml
- @attributes ||= collection.first.attribute_names - ['id', 'created_at', 'updated_at']
%table.table.table-striped{:class => "#{collection.first.class.to_s.downcase.pluralize} collection"}
  %thead
    %tr
      - @attributes.each do |field|
        %th= t_attr field, collection.first.class
      %th.action-links
  %tbody
    - collection.each do |r|
      %tr
        - @attributes.each do |field|
          %td= r.send(field) if r.respond_to?(field)
        %td.action-links
          = list_link_for(:edit, r)
          = list_link_for(:delete, r)

app/views/has_accounts/_show.html.haml
.form-view
  = render "form"

app/views/has_accounts/_sidebar.html.haml
%ul.nav.nav-list
  %li.nav-header= t('bookyt.main_navigation.accounting')
  %li= link_to t_title(:new, Booking), new_booking_path
  - BookingTemplate.where(:type => nil).limit(5).each do |template|
    %li= link_to template, [:new_booking, template]

  %li.nav-header Infos
  %li= link_to t_title(:index, Account), accounts_path

app/views/has_accounts/create.js.erb
$('#new_<%= resource_class.model_name.underscore %>').remove();
$('.<%= resource_class.model_name.tableize %>.collection tr:first-child').after('<%=j render resource %>');
initializeBehaviours();

app/views/has_accounts/destroy.js.erb
$('#<%= "#{resource_class.model_name.underscore}_#{resource.id}" %>').remove();
initializeBehaviours();

app/views/has_accounts/edit.html.haml
= contextual_links

= boot_page_title

= render 'form'

app/views/has_accounts/edit.js.erb
$('#new_<%= resource_class.model_name.underscore %>').remove();
$('.<%= resource_class.model_name.tableize %>.collection').before('<%=j render "form" %>');
initializeBehaviours();

app/views/has_accounts/index.html.haml
= contextual_links

= boot_page_title

= paginate collection
= render "list"

app/views/has_accounts/new.html.haml
= contextual_links

= boot_page_title

= render 'form'

app/views/has_accounts/new.js.erb
$('#new_<%= resource.class.name.underscore %>').remove();
$('.<%= resource_class.model_name.tableize %>.collection').before('<%=j render "form" %>');
initializeBehaviours();

app/views/has_accounts/show.html.haml
= contextual_links

= boot_page_title

= render "show"

app/views/has_accounts/show_modal.js.erb
$('.modal').remove();
$('body').append('<%=j render "show_modal" %>');
$('.modal').modal('show');

addComboboxBehaviour();
addAutofocusBehaviour();
$('.modal .select2').select2();

app/views/has_accounts/update.js.erb
$('#<%= resource.class.name.underscore %>_form').remove();
$('#<%= "#{resource.class.name.underscore}_#{resource.to_param}" %>').replaceWith('<%=escape_javascript render resource %>');
initializeBehaviours();